SystemOrganization addCategory: #'Twitter-Bootstrap-Seaside-Widgets-Components'!
SystemOrganization addCategory: #'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!WAFormInputTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/19/2012 13:45'!
twbsPlaceholderText: placeholderText
	self attributes at: 'placeholder' put: placeholderText! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:18'!
twbsAddErrorMessage: aStringOrRenderingBlock
	"Add a decoration that displays a twsb info alert with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (TWBSErrorMessageDecoration new message: aStringOrRenderingBlock; yourself)! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:18'!
twbsAddInfoMessage: aStringOrRenderingBlock
	"Add a decoration that displays a twsb info alert with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (TWBSInfoMessageDecoration new message: aStringOrRenderingBlock; yourself)! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsAddSuccessMessage: aStringOrRenderingBlock
	"Add a decoration that displays a twsb info alert with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (TWBSSuccessMessageDecoration new message: aStringOrRenderingBlock; yourself)! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmError: aStringOrRenderingBlock
	"Display a yes/no dialog with caption aString. Answer true if the response is yes, false if no."

	^ self wait: [ :cc | self twbsConfirmError: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmError: aStringOrRenderingBlock onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (TWBSYesOrNoDialog new
			twbsAddErrorMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmInfo: aStringOrRenderingBlock
	"Display a yes/no dialog with caption aString. Answer true if the response is yes, false if no."

	^ self wait: [ :cc | self twbsConfirmInfo: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:19'!
twbsConfirmInfo: aStringOrRenderingBlock onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (TWBSYesOrNoDialog new
			twbsAddInfoMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsConfirmSuccess: aStringOrRenderingBlock
	"Display a yes/no dialog with caption aString. Answer true if the response is yes, false if no."

	^ self wait: [ :cc | self twbsConfirmSuccess: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsConfirmSuccess: aStringOrRenderingBlock onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (TWBSYesOrNoDialog new
			twbsAddSuccessMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInform: aStringOrRenderingBlock
	"Display a dialog with aString to the user until he clicks the ok button."

	^ self wait: [ :cc | self twbsInform: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInform: aStringOrRenderingBlock onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (TWBSFormDialog new
			twbsAddInfoMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInformError: aStringOrRenderingBlock
	"Display a dialog with aString to the user until he clicks the ok button."

	^ self wait: [ :cc | self twbsInformError: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInformError: aStringOrRenderingBlock onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (TWBSFormDialog new
			twbsAddErrorMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:20'!
twbsInformSuccess: aStringOrRenderingBlock
	"Display a dialog with aString to the user until he clicks the ok button."

	^ self wait: [ :cc | self twbsInformSuccess: aStringOrRenderingBlock onAnswer: cc ]! !

!WAComponent methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/22/2012 08:21'!
twbsInformSuccess: aStringOrRenderingBlock onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (TWBSFormDialog new
			twbsAddSuccessMessage: aStringOrRenderingBlock;
			yourself)
		onAnswer: aBlock! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:29'!
twbsContainer
	^ self div
		class: 'container'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:29'!
twbsContainer: aBlock
	self div
		class: 'container';
		with: aBlock
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'JanVanDeSandt 3/22/2012 17:15'!
twbsIcon: aString
	(self tag: 'i')
		class: aString! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 14:05'!
twbsRow
	^ self div
		class: 'row'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 14:06'!
twbsRow: aBlock
	self div
		class: 'row';
		with: aBlock
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:30'!
twbsRowFluid
	^ self div
		class: 'row-fluid'! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:30'!
twbsRowFluid: aBlock
	self div
		class: 'row-fluid';
		with: aBlock
! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:30'!
twbsSpan: spanWidth
	^ self div
		class: 'span', spanWidth greaseString! !

!WAHtmlCanvas methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/10/2012 00:29'!
twbsSpan: spanWidth with: aBlock
	^ self div
		class: 'span', spanWidth greaseString;
		with: aBlock! !

WAFormDecoration subclass: #TWBSFormDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/23/2012 06:00'!
renderButtonsOn: html
	html div: [
		self buttons do: [ :each |
			html button
				class: 'btn';
				class: 'btn-primary' if: (each = buttons first);
				text: each;
				on: each of: self decoratedComponent ]
			separatedBy: [ html text: ' ' ] ]! !

!TWBSFormDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 20:10'!
renderContentOn: html
	html form
		defaultAction: [ self execute: self default ];
		with: [
			html fieldSet: [
				self renderNextOn: html.
				self renderButtonsOn: html ] ]! !

WAFormDialog subclass: #TWBSFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Components'!

!TWBSFormDialog methodsFor: 'actions' stamp: 'NickAger 3/21/2012 21:19'!
addForm
	form := TWBSFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!TWBSFormDialog methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 19:14'!
renderContentOn: html
	html hiddenInput 
		callback: [ validationError := nil ].
	validationError isNil
		ifFalse: [ self renderValidationError: validationError on: html ]! !

!TWBSFormDialog methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 19:08'!
renderValidationError: aString on: html
	html div
		class: 'alert';
		class: 'alert-error';
		with: aString! !

TWBSFormDialog subclass: #TWBSYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Components'!

!TWBSYesOrNoDialog methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 19:13'!
buttons
	^ #(yes no)! !

!TWBSYesOrNoDialog methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 19:13'!
no
	self answer: false! !

!TWBSYesOrNoDialog methodsFor: 'accessing' stamp: 'NickAger 3/21/2012 19:13'!
yes
	self answer: true! !

!WAAnchorTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 15:35'!
twbsDataToggleDropDown
	self attributes at: 'data-toggle' put: 'dropdown'! !

!WAAnchorTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 15:29'!
twbsDataTogglePill
	self attributes at: 'data-toggle' put: 'pill'! !

!WAAnchorTag methodsFor: '*twitter-bootstrap-seaside' stamp: 'NickAger 3/20/2012 15:29'!
twbsDataToggleTab
	self attributes at: 'data-toggle' put: 'tab'! !

WAMessageDecoration subclass: #TWBSErrorMessageDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSErrorMessageDecoration methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 07:40'!
renderContentOn: html
	html div
		class: 'alert';
		class: 'alert-error';
		with: message.
	self renderNextOn: html! !

WAMessageDecoration subclass: #TWBSInfoMessageDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSInfoMessageDecoration methodsFor: 'rendering' stamp: 'NickAger 3/21/2012 20:40'!
renderContentOn: html
	html div
		class: 'alert';
		class: 'alert-info';
		with: message.
	self renderNextOn: html! !

WAMessageDecoration subclass: #TWBSSuccessMessageDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Twitter-Bootstrap-Seaside-Widgets-Decorations'!

!TWBSSuccessMessageDecoration methodsFor: 'rendering' stamp: 'NickAger 3/22/2012 07:40'!
renderContentOn: html
	html div
		class: 'alert';
		class: 'alert-success';
		with: message.
	self renderNextOn: html! !
